package org.richfaces;

import org.ajax4jsf.test.base.RichSeleniumTest;
import org.ajax4jsf.test.base.SeleniumTestBase;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Parameters;
import org.testng.annotations.Test;


public class AjaxCommandButtonTest extends SeleniumTestBase implements RichSeleniumTest {

    public AjaxCommandButtonTest() {
        super("http", "localhost", "8080");
    }
    
    /**
     * This method are invoking before selenium tests started
     */
    @BeforeTest
    @Parameters( { "browser" })
    public void startSelenium(String browser) {
    	super.startSelenium(browser);
    }
    
    /**
     * This method are invoking after selenium tests completed
     */
    @AfterTest
    public void stopSelenium() {
    	super.stopSelenium();
    }

    @Test
    public void testAjaxCommandButtonComponent() throws Exception {
        renderPage("/faces/pages/ajaxCommandButton/ajaxButtonTest.xhtml");

        _testAjaxCommandButtonComponent(COMPONENT_PREFIX_INSIDE_TABLE);
        _testAjaxCommandButtonComponent(COMPONENT_PREFIX_INSIDE_PANEL);
    }

    private void _testAjaxCommandButtonComponent(String parentId) {
        // test inside DataTable
        String buttonId = parentId + "b1";
        String inputId = parentId + "_value";

        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "3");

        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "6");

        buttonId = parentId + "b2";

        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "6");

        buttonId = parentId + "b3";

        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "6");

        buttonId = parentId + "b4";

        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "1");

        buttonId = parentId + "b5";

        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "2");

        buttonId = parentId + "b1";

        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "5");

        buttonId = parentId + "b3";

        clickById(buttonId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "5");
    }

}
