/**
 * License Agreement.
 *
 *  JBoss RichFaces - Ajax4jsf Component Library
 *
 * Copyright (C) 2007  Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces;

import org.ajax4jsf.test.base.RichSeleniumTest;
import org.ajax4jsf.test.base.SeleniumTestBase;
import org.testng.Assert;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Parameters;
import org.testng.annotations.Test;

public class TabPanelTest extends SeleniumTestBase implements RichSeleniumTest {

	public TabPanelTest() {
		super("http", "localhost", "8080");
	}
	
	public TabPanelTest(String protocol, String host, String port) {
		super(protocol, host, port);
		// TODO Auto-generated constructor stub
	}
	
	/**
     * This method are invoking before selenium tests started
     */
    @BeforeTest
    @Parameters( { "browser" })
    public void startSelenium(String browser) {
    	super.startSelenium(browser);
    }
    
    /**
     * This method are invoking after selenium tests completed
     */
    @AfterTest
    public void stopSelenium() {
    	super.stopSelenium();
    }
    
    @Test
    public void testTabPanelComponent() throws Exception {
        renderPage("/faces/pages/tabPanel/tabPanelTest.xhtml");
        
        _testRichTabPanelComponent(COMPONENT_PREFIX_INSIDE_PANEL);
        _testRichTabPanelComponent(COMPONENT_PREFIX_INSIDE_TABLE);
    }
    
    private void _testRichTabPanelComponent(String parentId) {
    	String linkId = parentId + "tab2_lbl";
    	String tabId1 = parentId + "tab1";
    	String tabId2 = parentId + "tab2";
    	String tabId4 = parentId + "tab4";
        String inputId = parentId + "_value";
        String outputId = parentId + "_value2";

        clickById(linkId);
        waitForAjaxCompletion();
        AssertValueEquals(inputId, "tab2");
        Assert.assertTrue(isVisibleById(tabId2));
        AssertTextEquals(outputId, "2");
        
        
        linkId = parentId + "tab1_lbl";
        clickById(linkId);
        waitForPageToLoad();
        AssertValueEquals(inputId, "tab1");
        Assert.assertTrue(isVisibleById(tabId1));
        AssertTextEquals(outputId, "1");
        
        linkId = parentId + "tab3_lbl";
        clickById(linkId);
        AssertValueEquals(inputId, "tab1");
        Assert.assertTrue(isVisibleById(tabId1));
        
        linkId = parentId + "tab4_lbl";
        clickById(linkId);
        Assert.assertTrue(isVisibleById(tabId4));
    }

}
